/*
 *
 * Created: 25.12.2012 10:20:34
 *  Author: Nuckey
 */ 


#ifndef TESTER_CONFIG_H_
#define TESTER_CONFIG_H_


//###############################################################################################################
//# The OP_MHZ option tells the software the Operating Frequency of your ATmega.								#
//###############################################################################################################
#define OP_MHZ  8
//#define OP_MHZ = 1
#undef  F_CPU
#define F_CPU 8000000UL

//###############################################################################################################
//#	Select your language:																						#
//# Available languages are: LANG_ENGLISH, LANG_GERMAN, LANG_POLISH, LANG_CZECH, LANG_SLOVAK, LANG_SLOVENE,		#
//# LANG_DUTCH, LANG_RUSSIAN																					#
//###############################################################################################################
#define LANG_ENGLISH 0
#define LANG_GERMAN  1
#define LANG_POLISH  2
#define LANG_CZECH   3
#define LANG_SLOVAK  4
#define LANG_SLOVENE 5
#define LANG_DUTCH   6
#define LANG_RUSSIAN 7


#define UI_LANGUAGE LANG_GERMAN

//###############################################################################################################
//# The LCD_CYRILLIC option is necessary, if you have a display with cyrillic characterset.						#
//# This lcd-display don't have a character for Ohm and for ? (micro).											#
//# Russian language requires a LCD controller with russian characterset and option LCD_CYRILLIC!				#
//###############################################################################################################
//*#define LCD_CYRILLIC

//###############################################################################################################
//# Option STRIP_GRID_BOARD selects different board-layout, do not set for standard board!						#
//# The connection of LCD is totally different for both versions.												#
//###############################################################################################################
#define STRIP_GRID_BOARD

//###############################################################################################################
//# The WITH_SELFTEST option enables selftest function (only for mega168 or mega328).							#				
//###############################################################################################################
#define WITH_SELFTEST

//###############################################################################################################
//# AUTO_CAL will enable the autocalibration of zero offset of capacity measurement and							#
//# also the port output resistance values will be find out in SELFTEST section.								#
//# With a external capacitor a additionally correction of reference voltage is figured out for					#
//# low capacity measurement and also for the AUTOSCALE_ADC measurement.										#
//# The AUTO_CAL option is only selectable for mega168 and mega328.												#
//###############################################################################################################
#define AUTO_CAL

//###############################################################################################################
//# FREQUENCY_50HZ enables a 50 Hz frequency generator for up to one minute at the end of selftests.			#
//###############################################################################################################
#define FREQUENCY_50HZ

//###############################################################################################################
//# The WITH_AUTO_REF option enables reading of internal REF-voltage to get factors for the Capacity measuring. #
//###############################################################################################################
#define WITH_AUTO_REF

//###############################################################################################################
//# REF_C_KORR corrects the reference Voltage for capacity measurement (<40uF) and has mV units.				#
//# Greater values gives lower capacity results.																#
//###############################################################################################################
#define REF_C_KORR 12

//###############################################################################################################
//# REF_L_KORR corrects the reference Voltage for inductance measurement and has mV units.						#
//###############################################################################################################
#define REF_L_KORR 50

//###############################################################################################################
//# C_H_KORR defines a correction of 0.1% units for big capacitor measurement.									#
//# Positive values will reduce measurement results.															#
//###############################################################################################################
#define C_H_KORR 0

//###############################################################################################################
//# The WITH_UART option enables the software UART  (TTL level output at Pin PC3, 26).							#
//###############################################################################################################
#define WITH_UART
//#define SWUART_INVERT

//###############################################################################################################
//# The CAP_EMPTY_LEVEL  defines the empty voltage level for capacitors in mV.									#
//# Choose a higher value, if your Tester reports "Cell!" by unloading capacitors.								#
//###############################################################################################################
#define CAP_EMPTY_LEVEL 4

//###############################################################################################################
//# The AUTOSCALE_ADC option enables the autoscale ADC (ADC use VCC and Bandgap Ref).							#
//###############################################################################################################
#define AUTOSCALE_ADC
#define REF_R_KORR 3

//###############################################################################################################
//# The ESR_ZERO value define the zero value of ESR measurement (units = 0.01 Ohm).								#
//###############################################################################################################
#define ESR_ZERO 29

//###############################################################################################################
//# NO_AREF_CAP tells your Software, that you have no Capacitor installed at pin AREF (21).						#
//# This enables a shorter wait-time for AUTOSCALE_ADC function.												#
//###############################################################################################################
#define NO_AREF_CAP



//###############################################################################################################
//# The USE_EEPROM option specify where you wish to locate fix text and tables.									#
//# If USE_EEPROM is unset, program memory (flash) is taken for fix text and tables.							#
//###############################################################################################################
#define USE_EEPROM

//###############################################################################################################
//# Setting EBC_STYPE will select the old style to present the order of Transistor connection (EBC=...).		#
//# Omitting the option will select the 123=... style.  Every point is replaced by a character identifying		#
//# type of connected transistor pin (B=Base, E=Emitter, C=Collector, G=Gate, S=Source, D=Drain).				#
//###############################################################################################################
#define EBC_STYLE


//###############################################################################################################
//# The PULLUP_DISABLE option disable the pull-up Resistors of IO-Ports.										#
//# To use this option a external pull-up Resistor (10k to 30k)													#
//# from Pin 13 to VCC must be installed!																		#
//###############################################################################################################
#define PULLUP_DISABLE

//###############################################################################################################
//# The ANZ_MESS option specifies, how often an ADC value is read and accumulated.								#
//# Possible values of ANZ_MESS are 5 to 200 .																	#
//###############################################################################################################
#define ANZ_MESS 25

//###############################################################################################################
//# The POWER_OFF option enables the power off function, otherwise loop measurements infinitely					#
//# until power is disconnected with a ON/OFF switch (#define POWER_OFF).										#
//# If you have the tester without the power off transistors, you can deselect POWER_OFF .						#
//# If you have NOT selected the POWER_OFF option with the transistors installed,								#
//# you can stop measuring by holding the key several seconds after a result is									#
//# displayed. After releasing the key, the tester will be shut off by timeout.									#
//# Otherwise you can also specify, after how many measurements without found part								#
//# the tester will shut down (#define POWER_OFF=5).															#
//# The tester will also shut down with found part,																#
//# but successfull measurements are allowed double of the specified number.									#
//#  You can specify up to 255 empty measurements (#define POWER_OFF=255).										#
//###############################################################################################################
#define POWER_OFF 5

//###############################################################################################################
//# Option BAT_CHECK enables the Battery Voltage Check, otherwise the SW Version is displayed instead of Bat.	#
//# BAT_CHECK should be set for battery powered tester version.													#
//###############################################################################################################
#define BAT_CHECK

//###############################################################################################################
//# The BAT_OUT option enables Battery Voltage Output on LCD (if BAT_CHECK is selected).						#
//# If your 9V supply has a diode installed, use the BAT_OUT=600 form to specify the							#
//# threshold voltage of your diode to adjust the output value.													#
//# This threshold level is added to LCD-output and does not affect the voltage checking levels.				#
//###############################################################################################################
#define BAT_OUT 150

//###############################################################################################################
//# To adjust the warning-level and poor-level of battery check to the capability of a							#
//# low drop voltage regulator, you can specify the Option BAT_POOR=54 .										#
//# The unit for this option value is 100mV (0.1 Volt), 54 means a poor level of 5.4V.							#
//# The warning level is always 1V higher than the specified poor level.										#
//# Setting the poor level to low values is not recommended for rechargeable 9V Batteries,						#
//# because this increase the danger for deep discharge!!														#
//###############################################################################################################
#define BAT_POOR 64




#endif /* MAIN_CONFIG_H_ */